=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2006-12-12 02:46:36 +0000
+++ loggerhead/controllers/changelog_ui.py	2006-12-12 03:50:13 +0000
@@ -37,24 +37,19 @@
             revid = args[0]
         else:
             revid = h.last_revid
-        revlist = h.get_short_revision_history_from(revid)
-        entries = h.get_changelist(list(revlist)[:20])
-        
+
+        try:
+            revlist = h.get_short_revision_history_from(revid)
+            entries = h.get_changelist(list(revlist)[:20])
+        except:
+            raise HTTPRedirect(turbogears.url('/changes'))
+
         buttons = [
-            ('main', turbogears.url('/changes')),
+            ('top', turbogears.url('/changes')),
             ('inventory', turbogears.url([ '/inventory', revid ])),
             ('feed', turbogears.url('/atom')),
         ]
 
-        # i don't understand what's going on here, so it's commented out in
-        # the template.  i think it may be superceded by the "merged in" and
-        # "merged from" labels.
-        merge_revids = h.simplify_merge_point_list(h.get_merge_point_list(revid))
-        merge_points = [{
-            'revid': m_revid,
-            'revno': h.get_revno(m_revid),
-        } for m_revid in merge_revids]
-
         vals = {
             'branch_name': turbogears.config.get('loggerhead.branch_name'),
             'changes': entries,
@@ -64,7 +59,6 @@
             'pagesize': 20,
             'revid': revid,
             'buttons': buttons,
-            'merge_points': [util.Container(m) for m in merge_points],
         }
         if kw.get('style', None) == 'rss':
             vals['tg_template'] = 'loggerhead.templates.changelog-rss'

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2006-12-12 00:47:38 +0000
+++ loggerhead/controllers/revision_ui.py	2006-12-12 03:50:13 +0000
@@ -37,47 +37,21 @@
         else:
             revid = h.last_revid
 
-        rev = h.get_revision(revid)
-        if len(rev.parent_ids) > 0:
-            previous = rev.parent_ids[0]
-        else:
-            previous = None
-        
-        show_diff = kw.get('show_diff', False)
-        
-        parents = [util.Container(revid=r, revno=h.get_revno(r)) for r in rev.parent_ids]
-        children = [util.Container(revid=r, revno=h.get_revno(r)) for r in h.get_where_merged(revid)]
-        
-        comment = rev.message.splitlines()
-        if len(comment) == 1:
-            # robey-style 1-line long message
-            comment = textwrap.wrap(comment[0])
-        
-        changes = h.diff_revisions(revid, previous)
-        
         buttons = [
-            ('main', turbogears.url('/changes')),
+            ('top', turbogears.url('/changes')),
             ('inventory', turbogears.url([ '/inventory', revid ])),
-            ('log', turbogears.url([ '/changes', revid ])),
+            ('history', turbogears.url([ '/changes', revid ])),
         ]
         
         vals = {
+            'branch_name': turbogears.config.get('loggerhead.branch_name'),
             'revid': revid,
+            'change': h.get_change(revid, get_diffs=True),
             'buttons': buttons,
-            'revno': h.get_revno(revid),
-            'parents': parents,
-            'children': children,
-            'author': rev.committer,
-            'comment': comment,
-            'comment_clean': [util.html_clean(s) for s in comment],
-            'date': datetime.datetime.fromtimestamp(rev.timestamp),
-            'changes': changes,
-            'branch_name': turbogears.config.get('loggerhead.branch_name'),
             'util': util,
             'history': h,
             'scan_url': '/revision',
             'pagesize': 1,
         }
         return vals
- 
-        
\ No newline at end of file
+ 
\ No newline at end of file

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2006-12-12 02:46:36 +0000
+++ loggerhead/history.py	2006-12-12 03:50:13 +0000
@@ -164,7 +164,7 @@
         for revid in revid_list:
             yield self.get_change(revid)
     
-    def get_change(self, revid, parity=0):
+    def get_change(self, revid, get_diffs=False):
         try:
             rev = self._branch.repository.get_revision(revid)
         except (KeyError, bzrlib.errors.NoSuchRevision):
@@ -189,13 +189,20 @@
             short_comment = textwrap.wrap(short_comment)[0] + '...'
         
         parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in rev.parent_ids]
-        children = [util.Container(revid=r, revno=self.get_revno(r)) for r in self.get_where_merged(revid)]
+
+        merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
+        merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
         
         if len(parents) == 0:
             left_parent = None
         else:
             left_parent = rev.parent_ids[0]
-            
+        
+        message = rev.message.splitlines()
+        if len(message) == 1:
+            # robey-style 1-line long message
+            message = textwrap.wrap(message[0])
+
         entry = {
             'revid': revid,
             'revno': self.get_revno(revid),
@@ -204,11 +211,11 @@
             'age': util.timespan(now - commit_time) + ' ago',
             'short_comment': short_comment,
             'comment': rev.message,
-            'comment_clean': util.html_clean(rev.message),
+            'comment_clean': [util.html_clean(s) for s in message],
             'parents': parents,
-            'children': children,
+            'merge_points': merge_points,
             'left_child': self.get_left_child(revid),
-            'changes': self.diff_revisions(revid, left_parent, get_diffs=False),
+            'changes': self.diff_revisions(revid, left_parent, get_diffs=get_diffs),
         }
         return util.Container(entry)
     

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2006-12-12 02:46:36 +0000
+++ loggerhead/templates/changelog.kid	2006-12-12 03:50:13 +0000
@@ -6,12 +6,8 @@
     <title> ${branch_name} : changes </title>
     <link rel="alternate" type="application/atom+xml" href="${tg.url('/atom')}" title="RSS feed for ${branch_name}" />
     
-    <span py:def="revlink(revid, text)">
-        <a title="Show revision" href="${tg.url([ '/revision', revid ])}" class="revlink"> ${text} </a>
-    </span>
-
     <span py:def="loglink(revid, text)">
-        <a title="Show revision" href="${tg.url([ '/changes', revid ])}" class="revlink"> ${text} </a>
+        <a title="Show history" href="${tg.url([ '/changes', revid ])}" class="revlink"> ${text} </a>
     </span>
 </head>
 
@@ -21,19 +17,6 @@
 
 <h1> <span class="branch-name">${branch_name}</span> : changes </h1>
     
-<!-- i don't understand this -->
-<!--!span py:if="len(merge_points) > 0">
-    <table class="info-entry">
-        <tr> <th> merged in: </th>
-        <td> 
-            <span py:for="merge in merge_points" class="revision">
-	        ${revision_link(merge.revid, merge.revno)} <br />
-	        </span>
-	    </td>
-	    </tr>
-    </table>
-</span-->
-
 <div class="log-entries">
     <div py:for="entry in changes" class="revision">
         <div class="revision-header">
@@ -56,10 +39,10 @@
 	            <th class="date">date:</th>
 	            <td class="date"> ${entry.date.strftime('%d %b %Y %H:%M')} &nbsp; (${entry.age}) </td>
 	        </tr>
-	        <tr py:if="len(entry.children) > 1">
+	        <tr py:if="len(entry.merge_points) > 0">
 	            <th class="children"> merged in: </th>
 	            <td class="children">
-	                <span py:for="child in entry.children">  <span py:if="child.revid != entry.left_child"> ${loglink(child.revid, '(' + child.revno + ')')} &nbsp; </span></span>
+	                <span py:for="child in entry.merge_points"> ${loglink(child.revid, '(' + child.revno + ')')} &nbsp; </span>
 	            </td>
 	        </tr>
 	        <tr py:if="len(entry.parents) > 1">

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2006-12-11 21:51:02 +0000
+++ loggerhead/templates/master.kid	2006-12-12 03:50:13 +0000
@@ -12,7 +12,7 @@
 
 <!-- !define common navbar -->
 <span py:def="navbar()">
-    <!-- !requires: ${revid}, ${buttons}, ${pagesize} -->
+    <!-- !requires: ${revid}, ${buttons}, ${pagesize}, ${history}, ${scan_url} -->
     <div class="navbar">
         <div class="bar">
             <table>
@@ -45,14 +45,8 @@
     </div>
 </span>
 
-<span py:def="revision_link(revid, revno)">
-    <a title="Show revision info" href="${tg.url([ '/revision', revid ])}">
-        <span class="revno"> ${revno} </span>
-    </a>
-    <a title="Show changelog" href="${tg.url([ '/changes', revid ])}" class="log"> (log) </a>
-    <a title="Show revision info" href="${tg.url([ '/revision', revid ])}">
-        <span class="revid"> ${util.clean_revid(revid)} </span>
-    </a>
+<span py:def="revlink(revid, text)">
+    <a title="Show revision" href="${tg.url([ '/revision', revid ])}" class="revlink"> ${text} </a>
 </span>
 
 </head>

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2006-12-12 02:46:36 +0000
+++ loggerhead/templates/revision.kid	2006-12-12 03:50:13 +0000
@@ -3,71 +3,67 @@
     py:extends="'master.kid'">
 <head>
     <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> ${branch_name} : revision ${util.clean_revid(revid)} </title>
+    <title> ${branch_name} : revision ${change.revno} </title>
 </head>
 
 <body>
 
 ${navbar()}
 
-<h1> <span class="branch-name">${branch_name}</span> : revision ${revno} </h1>
+<h1> <span class="branch-name">${branch_name}</span> : revision ${change.revno} </h1>
 
 <div class="info-entries">
     <table>
         <tr>
-            <th class="revision">revision:</th>
-            <td class="revision"> ${revision_link(revid, revno)} </td>
-        </tr>
-        <tr py:if="parents">
-            <th class="revision">parents:</th>
-            <td class="revision">
-                <span py:for="p in parents">
-                    ${revision_link(p.revid, p.revno)} <br />
-                </span>
-            </td>
-        </tr>
-        <tr py:if="children">
-            <th class="revision">children:</th>
-            <td class="revision">
-                <span py:for="c in children">
-                    ${revision_link(c.revid, c.revno)} <br />
-                </span>
-            </td>
-        </tr>
-        <tr>
             <th class="author">committed by:</th>
-            <td class="author"> ${util.hide_email(author)} </td>
+            <td class="author"> ${util.hide_email(change.author)} </td>
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${date.strftime('%d %b %Y %H:%M')} </td>
-        </tr>
+            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
+        </tr>
+
+        <tr py:if="len(change.merge_points) > 0">
+            <th class="children"> merged in: </th>
+            <td class="children">
+                <span py:for="child in change.merge_points"> ${revlink(child.revid, '(' + child.revno + ')')} &nbsp; </span>
+            </td>
+        </tr>
+        <tr py:if="len(change.parents) > 1">
+        	<th class="parents"> merged from: </th>
+        	<td class="parents">
+        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid"> ${revlink(parent.revid, '(' + parent.revno + ')')} &nbsp; </span></span>
+        	</td>
+        </tr>
+
         <tr>
             <th class="description">description:</th>
-            <td class="description"> <span py:for="line in comment_clean">${XML(line)} <br /></span> </td>
+            <td class="description"><span py:for="line in change.comment_clean">${XML(line)} <br /></span> </td>
         </tr>
+        
         <tr class="divider"> <th></th> <td></td> </tr>
-        <tr py:if="changes.added">
+        
+        <tr py:if="change.changes.added">
             <th class="files"> files added: </th>
-            <td class="files"> <span py:for="filename in changes.added">${filename} <br /></span> </td>
+            <td class="files"> <span py:for="filename in change.changes.added">${filename} <br /></span> </td>
         </tr>
-        <tr py:if="changes.removed">
+        <tr py:if="change.changes.removed">
             <th class="files"> files removed: </th>
-            <td class="files"> <span py:for="filename in changes.removed">${filename} <br /></span> </td>
+            <td class="files"> <span py:for="filename in change.changes.removed">${filename} <br /></span> </td>
         </tr>
-        <tr py:if="changes.renamed">
+        <tr py:if="change.changes.renamed">
             <th class="files"> files renamed: </th>
-            <td class="files"> <span py:for="old_filename, new_filename in changes.renamed">${old_filename} => ${new_filename}<br /></span> </td>
+            <td class="files"> <span py:for="old_filename, new_filename in change.changes.renamed">${old_filename} => ${new_filename}<br /></span> </td>
         </tr>
-        <tr py:if="changes.modified">
+        <tr py:if="change.changes.modified">
             <th class="files"> files modified: </th>
-            <td class="files"> <span py:for="item in changes.modified">${item.filename} <br /></span> </td>
+            <td class="files"> <span py:for="item in change.changes.modified">${item.filename} <br /></span> </td>
         </tr>
     </table>
 </div>
 
-<div class="diff" py:if="changes.modified">
-    <table py:for="item in changes.modified" class="diff-block">
+<div class="diff" py:if="change.changes.modified">
+    <table py:for="item in change.changes.modified" class="diff-block">
         <tr><th class="filename"> ${item.filename} </th></tr>
         <tr><td>
             <table py:for="chunk in item.chunks" class="diff-chunk">

